C# Solidworks二次开发:涉及主框架相关API详解(第二讲)

大家好,今天要介绍的是和主框架Frame相关的几个API,之前我也在一篇文章中提过一些,没看过的家人可以看一下:

C# Solidworks二次开发:获取主窗口API和创建新活动窗口API详解_solidworks二次开发c#-CSDN博客

下面介绍一下今天要讲的几个API:

(1)第一个为GetHwnd,这个API的含义为获取主框架的窗口句柄(备注:除了×64应用以外的),下面是其API的具体解释:

其没有输入参数,输出参数为handle。

(2)第二个为GetHwnd×64,这个API的含义为获取64为应用程序中主框架的窗口句柄,下面是其API的具体解释:

其参数同上。

(3)第三个为GetModelWindowCount,这个API的含义为获取此框架的子模型窗口数,下面是API的具体含义:

其没有输入参数,输出参数为窗口数量。

(4)第四个为ShowModelWindow,这个API的含义为显示客户端模型窗口,下面是API的具体解释:

官方的使用例子,如下所示:

This example shows how to switch documents by opening documents in their own and client model windows.

//----------------------------------------------
// Preconditions:
// 1. Verify that the specified documents to open exist.
// 2. Open the Immediate window.
//
// Postconditions:
// 1. Opens the specified documents in their own 
//    and client model windows.
// 2. Closes all open documents.
// 3. Examine the Immediate window.
//----------------------------------------------
 
using SolidWorks.Interop.sldworks;
using SolidWorks.Interop.swconst;
using System.Runtime.InteropServices;
using System;
using System.Diagnostics;
 
namespace FrameCSharp.csproj
{
    public partial class SolidWorksMacro
    {
 
        public void Main()
        {
            ModelDoc2 swModelDoc = default(ModelDoc2);
            Frame swFrame = default(Frame);
            ModelWindow swModelWindow = default(ModelWindow);
            object[] modelWindows = null;
            int errors = 0;
            int warnings = 0;
            int HWnd = 0;
            string fileName = null;
            string strFolder = null;
 
            //Open the specified documents in their own windows
            fileName = "C:\\Users\\Public\\Documents\\SOLIDWORKS\\SOLIDWORKS 2018\\samples\\tutorial\\assemblymates\\knee.sldprt";
            swModelDoc = (ModelDoc2)swApp.OpenDoc6(fileName, (int)swDocumentTypes_e.swDocPART, (int)swOpenDocOptions_e.swOpenDocOptions_Silent, "", ref errors, ref warnings);
            //Open client model window containing the active document
            swApp.CreateNewWindow();
 
            fileName = "C:\\Users\\Public\\Documents\\SOLIDWORKS\\SOLIDWORKS 2018\\samples\\tutorial\\assemblymates\\bracket.sldprt";
            swModelDoc = (ModelDoc2)swApp.OpenDoc6(fileName, (int)swDocumentTypes_e.swDocPART, (int)swOpenDocOptions_e.swOpenDocOptions_Silent, "", ref errors, ref warnings);
            //Open client model window containing the active document
            swApp.CreateNewWindow();
 
            fileName = "C:\\Users\\Public\\Documents\\SOLIDWORKS\\SOLIDWORKS 2018\\samples\\tutorial\\assemblymates\\clamp.sldprt";
            swModelDoc = (ModelDoc2)swApp.OpenDoc6(fileName, (int)swDocumentTypes_e.swDocPART, (int)swOpenDocOptions_e.swOpenDocOptions_Silent, "", ref errors, ref warnings);
            //Open client model window containing the active document
            swApp.CreateNewWindow();
 
            swFrame = (Frame)swApp.Frame();
            modelWindows = (object[])swFrame.ModelWindows;
            Debug.Print("Open documents in their own windows:");
            foreach (object obj in modelWindows)
            {
                swModelWindow = (ModelWindow)obj;
                //Get the model document in this model window
                swModelDoc = (ModelDoc2)swModelWindow.ModelDoc;
                //Rebuild the document
                swModelDoc.EditRebuild3();
                swModelDoc = null;
                //Show the model window
                Debug.Print("");
                swFrame.ShowModelWindow(swModelWindow);
                //Get and print the model window handle
                HWnd = swModelWindow.HWnd;
                Debug.Print("  Model window handle: " + HWnd);
                //Get and print the model title as it is seen in the model window's title bar
                Debug.Print("  Model title as it seen in the model's window's title bar: " + swModelWindow.Title);
            }
 
            strFolder = "";
            //Specify true to close all documents, specify false to close
            //only the documents not modified
            swApp.CloseAllDocuments(true);
 
        }
 
        /// <summary>
        ///  The SldWorks swApp variable is pre-assigned for you.
        /// </summary>
        public SldWorks swApp;
    }
}

上面就是今天要介绍的四个API,都是和主框架有关的。

我们下篇文章再见。

  • 22
    点赞
  • 24
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 1
    评论
C# SolidWorks二次开发是指使用C#编程语言来扩展和定制SolidWorks软件的功能。下面是进行C# SolidWorks二次开发的步骤: 1. 环境配置: - 首先,确保您已经安装了SolidWorks软件和Visual Studio开发环境。 - 然后,安装SolidWorks API SDK。您可以在SolidWorks安装包中找到"SolidWorks API SDK.msi"文件,并按照安装向导进行安装。 2. 创建插件Addin: - 打开Visual Studio,并创建一个新的C#项目。 - 在项目中,添加对SolidWorks API的引用。您可以在项目的引用中添加SolidWorks.Interop.sldworks和SolidWorks.Interop.swcommands等引用。 - 创建一个类,并实现SolidWorks的事件接口,例如ISwAddin或ISwAddin2。 - 实现所需的功能,例如创建自定义工具栏、菜单或按钮,并实现其相应的事件处理程序。 3. 运行和调试: - 在Visual Studio中编译和生成项目。 - 将生成的插件文件(.dll文件)复制到SolidWorks的插件目录中,一般为"C:\ProgramData\SolidWorks\SOLIDWORKS 20XX\addins"。 - 启动SolidWorks软件,您应该能够看到您创建的自定义工具栏、菜单或按钮。 - 单击按钮或执行其他操作来测试和调试您的插件功能。 通过以上步骤,您可以开始使用C#编程语言进行SolidWorks的二次开发,实现自定义的功能和工具,以满足您的需求。请确保在开发过程中参考官方文档和其他相关教程,以便更好地理解和掌握C# SolidWorks二次开发的技术。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

喵桑さん

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值